﻿package com.weixinsf.utils;
/**
 * 
 * <p>Description: 获得微信操作中的一些基本信息工具类</p>
 * 使用wechat4j.jar包
 * @author liufeng
 * @date 2016-6-30
 * @version 1.0
 */
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;

import net.sf.json.JSONObject;

import org.apache.commons.lang.StringUtils;
import org.apache.struts2.ServletActionContext;
import org.sword.wechat4j.token.TokenProxy;

public class TokenProxys extends TokenProxy {
	/**
	 * 获得公众号的全局唯一票据access_token,公众号调用各接口时都需使用access_token
	 * @return
	 */
	public static String accessTokens(){
		//简单的操作header解决了ajax跨域问题
		ServletActionContext.getResponse().setHeader("Access-Control-Allow-Origin", "*");
		String accessToken = "";
		accessToken = accessToken();
		return accessToken;
	}
	
	public static String jsApiTickets(){
		//简单的操作header解决了ajax跨域问题
		ServletActionContext.getResponse().setHeader("Access-Control-Allow-Origin", "*");
		String jsapiTicket = "";
		jsapiTicket = jsApiTicket();
		return jsapiTicket;
	}
	
	
	/**
	 * 此方法用于获取微信用户的openid，access_token,expires_in,refresh_token,scope
	 * @param code:获得上述字段值所需的参数
	 * @return map，封装了所需的值
	 */
	public static Map<String,String> getAuthority(String code){
		Map<String,String> map = new HashMap<String, String>();
		String openid = "";
		String access_token = "";
		String refresh_token = "";
		String scope = "";
		String url = "https://api.weixin.qq.com/sns/oauth2/access_token?appid=wx79dde9ca8c97ad62&secret=2f9fe41e67019e0c347a75d33d49c96d&code="+code+"&grant_type=authorization_code";
		try {   
            URL urls = new URL(url);  
            java.net.HttpURLConnection conn = (java.net.HttpURLConnection)urls.openConnection();  
            conn.setDoOutput(true);  
            conn.setRequestMethod("POST");  
            InputStream inputStream = conn.getInputStream();    
            byte[] data = readInputStream(inputStream);
            String result=new String(data, "UTF-8");
            JSONObject jb = JSONObject.fromObject(result);
            openid = (String)jb.get("openid");
            access_token = (String)jb.get("access_token");
            refresh_token = (String)jb.get("refresh_token");
            scope = (String)jb.get("scope");
            if (StringUtils.isNotEmpty(openid)) {
				map.put("openid", openid);
			}
            if (StringUtils.isNotEmpty(access_token)) {
            	map.put("access_token", access_token);
            }
            if (StringUtils.isNotEmpty(refresh_token)) {
            	map.put("refresh_token", refresh_token);
            }
            if (StringUtils.isNotEmpty(scope)) {
            	map.put("scope", scope);
            }
            
            if(inputStream!=null){  
                inputStream.close();  
            }
        } catch (Exception e) {  
            e.printStackTrace();
        }
		return map;
	}
	
	
	/**
	 * 根据网页授权access_token和微信用户的openId获得用户基本信息
	 * @param access_token
	 * @param openId 
	 * @return map，封装了所需的值
	 */
	public static Map<String,String> getUserInfo(String access_token,String openId){
		Map<String,String> map = new HashMap<String, String>();
		//用户的唯一标识
		String openid = "";
		//用户昵称
		String nickname = "";
		//用户的性别，值为1时是男性，值为2时是女性，值为0时是未知
		String sex = "";
		//语言
		String language = "";
		//普通用户个人资料填写的城市
		String city = "";
		//用户个人资料填写的省份
		String province = "";
		//国家，如中国为CN
		String country = "";
		//用户头像，最后一个数值代表正方形头像大小（有0、46、64、96、132数值可选，0代表640*640正方形头像），用户没有头像时该项为空。若用户更换头像，原有头像URL将失效。
		String headimgurl = "";
		//用户特权信息，json 数组，如微信沃卡用户为（chinaunicom）
		String privilege = "";
		//获取用户基本信息的url
		String url = "https://api.weixin.qq.com/sns/userinfo?access_token="+access_token+"&openid="+openId;
		try {   
			URL urls = new URL(url);  
			java.net.HttpURLConnection conn = (java.net.HttpURLConnection)urls.openConnection();  
			conn.setDoOutput(true);  
			conn.setRequestMethod("POST");  
			InputStream inputStream = conn.getInputStream();    
			byte[] data = readInputStream(inputStream);
			String result=new String(data, "UTF-8");
			JSONObject jb = JSONObject.fromObject(result);
			openid = (String)jb.get("openid");
			nickname = (String)jb.get("nickname");
			sex = jb.get("sex").toString();
			language = (String)jb.get("language");
			city = (String)jb.get("city");
			province = (String)jb.get("province");
			country = (String)jb.get("country");
			headimgurl = (String)jb.get("headimgurl");
			privilege = jb.get("privilege").toString();
			if (StringUtils.isNotEmpty(openid)) {
				map.put("openid", openid);
			}
			if (StringUtils.isNotEmpty(nickname)) {
				map.put("nickname", nickname);
			}
			if (StringUtils.isNotEmpty(sex)) {
				map.put("sex", sex);
			}
			if (StringUtils.isNotEmpty(language)) {
				map.put("language", language);
			}
			if (StringUtils.isNotEmpty(city)) {
				map.put("city", city);
			}
			if (StringUtils.isNotEmpty(province)) {
				map.put("province", province);
			}
			if (StringUtils.isNotEmpty(country)) {
				map.put("country", country);
			}
			if (StringUtils.isNotEmpty(headimgurl)) {
				map.put("headimgurl", headimgurl);
			}
			if (StringUtils.isNotEmpty(privilege)) {
				map.put("privilege", privilege);
			}
			
			if(inputStream!=null){  
				inputStream.close();  
			}
		} catch (Exception e) {  
			e.printStackTrace();
		}
		return map;
	}
	
	
	/** 
     * 从输入流中获取字节数组 
     * @param inputStream 
     * @return 
     * @throws IOException 
     */  
    public static  byte[] readInputStream(InputStream inputStream) throws IOException {    
        byte[] buffer = new byte[1024];    
        int len = 0;    
        ByteArrayOutputStream bos = new ByteArrayOutputStream();    
        while((len = inputStream.read(buffer)) != -1) {    
            bos.write(buffer, 0, len);    
        }    
        bos.close();    
        return bos.toByteArray();    
    } 
}
